/*
 * *************************************************
 * Copyright (c) 2018 QMTH. All Rights Reserved.
 * Created by Deason on 2018-07-31 17:19:06.
 * *************************************************
 */

package cn.com.qmth.examcloud.app.service.impl;

import cn.com.qmth.examcloud.app.core.utils.HttpUtils;
import cn.com.qmth.examcloud.app.model.Result;
import cn.com.qmth.examcloud.app.service.PropertyService;
import cn.com.qmth.examcloud.app.service.QuestionPoolService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.net.URLEncoder;

/**
 * 题库业务服务接口
 *
 * @author: fengdesheng
 * @since: 2018/7/16
 */
@Service
public class QuestionPoolServiceImpl implements QuestionPoolService {
    private static Logger log = LoggerFactory.getLogger(QuestionPoolServiceImpl.class);
    @Autowired
    private PropertyService propertyService;

    @Override
    public String downloadPaper(String paperId, String orgName) throws Exception {
        //封装请求参数
        orgName = URLEncoder.encode(orgName, "utf-8");
        return String.format("%s/api/ecs_ques/paper/export/%s/PAPER/%s/%s/offLine", propertyService.getQuestionPoolUrl(), paperId, orgName, paperId);
    }

    @Override
    public Result getPaperDetail(String key, String token, String paperId) throws Exception {
        //封装请求参数
        final String requestUrl = String.format("%s/api/ecs_ques/paper/%s", propertyService.getQuestionPoolUrl(), paperId);
        Result<String> result = HttpUtils.doGet(requestUrl, key, token);
        if (result.isSuccess()) {
            //过滤掉为空的属性
            result.setData(HttpUtils.filterNullAttributes(result.getData()));
        }
        return result;
    }

}